package animation.balg;

import static java.lang.Math.sqrt;
import static java.lang.Math.pow;
import static java.lang.Math.atan2;

public class RadDaten {
	double xs, ys; 	// Schwerpunkt (Bildschirmkoordinaten)
	double s;
	double xz, yz;	// Schwerpunkt (Bildschirmkoordinaten)
	double area;
	double mass;
	double scaling;
	double g;
	double momentOfInertia;

	public RadDaten() {
		xs = 0.0;
		ys = 0.0;
		xz = 0.0;
		yz = 0.0;
		area = 0.0;
		mass = 0.0;
		momentOfInertia = 0.0;
	}

	public void setMassentraegheitsmoment(double value) {
		momentOfInertia = value;
	}

	public double getMassenTraegheitsmoment() {
		return momentOfInertia;
	}

	public double getXsPixel() {
		return xs;
	}
	
	public double getXsMeter() {
		return (xs - xz) * scaling;
	}

	public void setXsPixel(double xs) {
		this.xs = xs;
	}

	public double getYsMeter() {
		return (yz - ys) * scaling;
	}
	
	public double getYsPixel() {
		return ys;
	}

	public void setYsPixel(double ys) {
		this.ys = ys;
	}

	public double getAreaQuadratmeter() {
		return area * pow(scaling,2);
	}

	public void setAreaPixel(double area) {
		this.area = area;
	}

	public double getXz() {
		return xz;
	}

	public void setXz(double xz) {
		this.xz = xz;
	}

	public double getYz() {
		return yz;
	}

	public void setYz(double yz) {
		this.yz = yz;
	}

	public double getSkalierung() {
		return scaling;
	}

	public void setSkalierung(double scaling) {
		this.scaling = scaling;
	}

	public double getMasse() {
		return mass;
	}

	public void setMasse(double mass) {
		this.mass = mass;
	}

	public double getSchwerpunktradius() {
		// Abstand Schwerpunkt von Zentrum (in m)
		return scaling * sqrt(pow(xs - xz, 2) + pow(yz - ys, 2));
	}

	public double getPhi() {
		return atan2(yz - ys, xs - xz);
	}

	public void setSchwerpunktradius(double s) {
		this.s = s;
	}

	public double getGravitationskonstante() {
		return g;
	}

	public void setGravitationskonstante(double g) {
		this.g = g;
	}

}
