package animation.pendel;

import gui.DecimalField;

import java.util.Vector;

import javax.swing.JLabel;
import javax.swing.JPanel;

public abstract class PanelParameter extends JPanel {

	private static final long serialVersionUID = 1L;

	protected Vector<Vector<String>> rowData;
	protected Vector<String> columnNames;
	

	protected final int DF_WITH = 50;
	protected final int DF_HEIGHT = 22;
	protected final int LB_WIDTH = 100;
	protected final int LB_HEIGHT = 22;

	protected abstract void initTable(JPanel p);
	public abstract void clearTable();
	
	protected void setParameter(JPanel p, 
			DecimalField df, 
			String text, 
			int x, int y, 
			double value, double minValue, double maxValue) {
		JLabel lb = new JLabel(text);
		p.add(lb);
		lb.setBounds(x, y, LB_WIDTH, LB_HEIGHT);
		p.add(df);
		df.setBounds(x + LB_WIDTH + 10, y, DF_WITH, DF_HEIGHT);
		df.setLimits(minValue,maxValue);
		df.setValue(value);
		
	}

	protected void setDecimalfield(JPanel p, 
			DecimalField df, 
			String text, 
			int x, int y, int w1, int w2) {
		JLabel lb = new JLabel(text);
		p.add(lb);
		lb.setBounds(x, y, w1, LB_HEIGHT);
		p.add(df);
		df.setBounds(x + w1 + 10, y, w2, DF_HEIGHT);
	}
	public PanelParameter() {
		setLayout(null);
	}
	
	
}
