package animation.spiralrad;

import gui.MainFrame;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;

import animation.pendel.DlgPendel;

//import animation.balg.PanelBalg;
//import animation.balg.PanelBalgParameter;

public class DlgSpiralradPhysikalischeDaten extends DlgPendel {
	
	private static final long serialVersionUID = 1L;

	@SuppressWarnings("unused")
	private PanelSpiralrad spiralPanel;
	private PanelSpiralradParameter parameterPanel;
	
	private final int DLG_PANEL_WIDTH = 950;
	private final int DLG_PANEL_HEIGHT = 520;

	private final int DRAWPANEL_X = 20;
	private final int DRAWPANEL_Y = 20;
	private final int DRAWPANEL_WIDTH = 440;
	private final int DRAWPANEL_HEIGHT = 440;

	private final int PARAM_PANEL_X = 480;
	private final int PARAM_PANEL_Y = 10;
	private final int PARAM_PANEL_WIDTH = 500;
	private final int PARAM_PANEL_HEIGHT = 400;

	private final int X1 = PARAM_PANEL_X;
	private final int Y1 = PARAM_PANEL_HEIGHT + 35;
	private final int WBUT = 90;
	private final int HBUT = 25;
	
	JButton butDauernd;
	JButton butReset;
	JButton butSchritt;

	public DlgSpiralradPhysikalischeDaten(MainFrame mainFrame) {

		this.mainFrame = mainFrame;
		setTitle("Multispiralrad #443 Laborator");
		setSize(DLG_PANEL_WIDTH, DLG_PANEL_HEIGHT);
	
		parameterPanel = new PanelSpiralradParameter();
		parameterPanel.setBounds(PARAM_PANEL_X, PARAM_PANEL_Y,
				PARAM_PANEL_WIDTH, PARAM_PANEL_HEIGHT);
		pBackground.add(parameterPanel);

		spiralPanel = new PanelSpiralrad(parameterPanel);
		spiralPanel.setBounds(DRAWPANEL_X, DRAWPANEL_Y, DRAWPANEL_WIDTH,
				DRAWPANEL_HEIGHT);
		pBackground.add(spiralPanel);
		parameterPanel.setSpiralradPanel(spiralPanel);

		butSchritt = new JButton("Schritt");
		butSchritt.setBounds(X1, Y1, WBUT, HBUT);
		butSchritt.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				cmdSchritt();
			}
		});
		pBackground.add(butSchritt);
		
		
		butDauernd = new JButton("Dauernd");
		butDauernd.setBounds(X1 + WBUT + 10, Y1, WBUT, HBUT);
		butDauernd.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				cmdDauernd();
			}
		});
		pBackground.add(butDauernd);
		
		butReset = new JButton("Reset");
		butReset.setBounds(X1 + 2 * (WBUT + 10), Y1, WBUT, HBUT);
		butReset.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				cmdReset();
			}
		});
		pBackground.add(butReset);

		
		JButton butCancel = new JButton("Beenden");
		butCancel.setBounds(X1 + 3 * (WBUT + 10)+10, Y1, WBUT, HBUT);
		butCancel.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				cmdCancel();
			}
		});
		pBackground.add(butCancel);
	}

	private void cmdReset() {
		if (butDauernd.getText().compareTo("Stop")==0) {
			stopAnimationDauernd();
		}
		spiralPanel.reset();
		parameterPanel.reset();
		spiralPanel.repaint();
	}
	
	private void startAnimationDauernd() {
		butDauernd.setText("Stop");
		butSchritt.setEnabled(false);
		spiralPanel.startAnimation();
	}
	
	private void stopAnimationDauernd() {
		butDauernd.setText("Dauernd");
		spiralPanel.stopAnimation();
		butSchritt.setEnabled(true);
	}
	
	protected void cmdSchritt() {
		//balgPanel.init_phi();
		spiralPanel.repaint();
	}
	
	protected void cmdDauernd() {
		if (butDauernd.getText().compareTo("Dauernd")==0) {
			startAnimationDauernd();
		}
		else {
			stopAnimationDauernd();
		}
	}
	
	protected void cmdCancel() {
		spiralPanel.stopAnimation();
		spiralPanel.setVisible(false);
		dispose();
	}

}
