package animation.utils;

import java.awt.geom.Line2D;

public class Test {

	public boolean intersectLines(Line2D l, Line2D m)
			throws IllegalArgumentException {
		// Quelle:
		// http://forum.worldofplayers.de/forum/threads/783387-JAVA-Methode-zum-Schnittpunkt-zweier-Geraden(am-besten-Line2D-Objecte)-berechnen

		// Wegen der Lesbarkeit
		double lx1 = l.getX1();
		double lx2 = l.getX2();
		double ly1 = l.getY1();
		double ly2 = l.getY2();
		
		double mx1 = m.getX1();
		double mx2 = m.getX2();
		double my1 = m.getY1();
		double my2 = m.getY2();

		if ((lx1==mx1)&&(lx2==mx2)&&(ly1==my1)&&(ly2==my2)) {
			System.out.println("Gleich.");
			return true;
		}
		
		// Zaehler
		double zx = (lx1 * ly2 - ly1 * lx2) * (mx1 - mx2) - (lx1 - lx2)
				* (mx1 * my2 - my1 * mx2);
		double zy = (lx1 * ly2 - ly1 * lx2) * (my1 - my2) - (ly1 - ly2)
				* (mx1 * my2 - my1 * mx2);

		// Nenner
		double n = (lx1 - lx2) * (my1 - my2) - (ly1 - ly2) * (mx1 - mx2);

		// Koordinaten des Schnittpunktes
		double x = zx / n;
		double y = zy / n;

		// Vielleicht ist bei der Division durch n etwas schief gelaufen
		if (Double.isNaN(x) & Double.isNaN(y)) {
			System.out.println("Schnittpunkt nicht eindeutig.");
			return false;
		}
		// Test ob der Schnittpunkt auf den angebenen Strecken liegt oder
		// auerhalb.
		if ((x - lx1) / (lx2 - lx1) > 1 || (x - mx1) / (mx2 - mx1) > 1
				|| (y - ly1) / (ly2 - ly1) > 1 || (y - my1) / (my2 - my1) > 1) {
			System.out.println("Schnittpunkt liegt auerhalb.");
			return false;
		}
		System.out.println("Schnittpunkt: " + x + "," + y);
		return true;
	}

	public static void main(String[] args) {

		Test test = new Test();
		Line2D g1 = new Line2D.Double(10, 10, 40, 40);
		Line2D g2 = new Line2D.Double(10, 10, 40, 40);

		test.intersectLines(g1, g2);

		/*
		 * if (test.g_gleich (g1, g2)) System.out.println("g1 und g2 sind
		 * gleich."); else if (test.parallel (g1, g2)) System.out.println("g1
		 * und g2 sind parallel"); else { System.out.print("Die Geraden
		 * schneiden sich im Punkt: P("); Point2D schnittpunkt = test.schnitt
		 * (g1, g2); System.out.print(schnittpunkt.getX()+",");
		 * System.out.println(schnittpunkt.getY()+")."); }
		 */
	}

}
