package gui;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.image.BufferedImage;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.TitledBorder;



public class CenterOfAreaPanel extends JPanel {
	
	private static final long serialVersionUID = 1L;
	private JTextField [] tfCogColor;
	private JTextField [] tfWeight;
	private JTextField [] tfCogCoords;
	private JTextField tfCogCoordTotal;
	private JTextField [] tfNumPixels;
	private JCheckBox[] cbSelectedCogColor;
	private CenterOfArea[] coa; 
	private Double[] dblWeight;
	
	private JButton butSetCenterOfArea;
	
	private BufferedImage image;
	private Rastered2DImage raster;
	private ImageDrawPanel imageDrawPanel;
	@SuppressWarnings("unused")
	private ImageBasePanel imageBasePanel;
	private Color actualCOAColor;
	
	public CenterOfAreaPanel(ImageBasePanel imageBasePanel) {
		setLayout(null);
		
		final int x0 = 10;
		final int w0 = 20; 
		final int h0 = 30;
		final int x1 = x0+w0+5;
		final int w1 = 20;
		final int x2 = x1+w1+5;
		final int w2 = 40;
		final int x3 = x2+w2+5;
		final int w3 = 80;
		final int x4 = x3+w3+5;
		final int w4 = 80;
		final int h = 20;
		final int h1 = 25;
		
		int yp = 0;
		this.imageBasePanel = imageBasePanel;
		this.imageDrawPanel = imageBasePanel.getImageDrawPanel();
		
		this.setSize(new Dimension(280,220));
		
		TitledBorder blackline = BorderFactory.createTitledBorder("Center of Area");
		setBorder(blackline); 
		
		tfCogColor = new JTextField[guiConsts.MAX_NUM_COA];
		tfWeight = new JTextField[guiConsts.MAX_NUM_COA];
		tfCogCoords = new JTextField[guiConsts.MAX_NUM_COA];
		cbSelectedCogColor = new JCheckBox[guiConsts.MAX_NUM_COA+1];
		tfNumPixels = new JTextField[guiConsts.MAX_NUM_COA];
		dblWeight = new Double[guiConsts.MAX_NUM_COA];
		coa = new CenterOfArea[guiConsts.MAX_NUM_COA+1];
		
		actualCOAColor = Color.WHITE;
		
		JLabel lbColor = new JLabel("Col.");
		lbColor.setBounds(x1,h0,30,h);
		add(lbColor);
		
		JLabel lbWeight = new JLabel("Weight");
		lbWeight.setBounds(x2,h0,50,h);
		add(lbWeight);
		
		JLabel lbCenter = new JLabel("Center");
		lbCenter.setBounds(x3,h0,80,h);
		add(lbCenter);
		
		JLabel lbNumPixels = new JLabel("Pixels");
		lbNumPixels.setBounds(x4,h0,40,h);
		add(lbNumPixels);
	
		
		
		for (int i = 0; i< guiConsts.MAX_NUM_COA; i++) {
			yp++;
			cbSelectedCogColor[i] = new JCheckBox();
			cbSelectedCogColor[i].setBounds(x0,h0+yp*h1,w0,h);
			add(cbSelectedCogColor[i]);
			
			tfCogColor[i] = new JTextField();
			tfCogColor[i].setBounds(x1,h0+yp*h1,h,h);
			tfCogColor[i].setBackground(Color.white);
			tfCogColor[i].addMouseListener(new MouseListener(){
				public void mouseClicked(MouseEvent arg0) {
					arg0.getComponent().setBackground(actualCOAColor);
				}
				public void mouseEntered(MouseEvent arg0) {}
				public void mouseExited(MouseEvent arg0) {}
				public void mousePressed(MouseEvent arg0) {}
				public void mouseReleased(MouseEvent arg0) {}}
			);
			tfCogColor[i].setEditable(false);
			add(tfCogColor[i]);
			
			tfWeight[i] = new JTextField("1.0");
			tfWeight[i].setBounds(x2,h0+yp*h1,w2,h);
			add(tfWeight[i]);
			
			dblWeight[i] = 1.0;
			
			tfCogCoords[i] = new JTextField();
			tfCogCoords[i].setBounds(x3,h0+yp*h1,w3,h);
			tfCogCoords[i].setBackground(Color.white);
			tfCogCoords[i].setEditable(false);
			add(tfCogCoords[i]);
			
			tfNumPixels[i] = new JTextField();
			tfNumPixels[i].setBounds(x4,h0+yp*h1,w4,h);
			tfNumPixels[i].setBackground(Color.white);
			tfNumPixels[i].setEditable(false);
			add(tfNumPixels[i]);
		}
		yp++;
		
		cbSelectedCogColor[guiConsts.MAX_NUM_COA] = new JCheckBox();
		cbSelectedCogColor[guiConsts.MAX_NUM_COA].setBounds(x0,h0+yp*h1,w0,h);
		add(cbSelectedCogColor[guiConsts.MAX_NUM_COA]);
		
		JLabel lbTotal = new JLabel("Total");
		lbTotal.setBounds(x2,h0+yp*h1,40,h);
		add(lbTotal);
		
		tfCogCoordTotal = new JTextField();
		tfCogCoordTotal.setBounds(x3,h0+yp*h1,w3,h);
		tfCogCoordTotal.setBackground(Color.white);
		tfCogCoordTotal.setEditable(false);
		add(tfCogCoordTotal);
		
		yp++;
		yp++;
		butSetCenterOfArea = new JButton("Calculate");
		butSetCenterOfArea.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				cmdSetCenterOfArea();
			}});
		butSetCenterOfArea.setBounds(x3,h0+yp*h1,w3+5+w4,25);
		add(butSetCenterOfArea);
		
		cbSelectedCogColor[0].setSelected(true);
	}
	
	public void cmdSetCenterOfArea() {
		BufferedImage image = imageDrawPanel.getClonedImage();
		if (image == null) return;
		raster = convertTo2D(image);
		imageDrawPanel.getCentersOfArea().clear();
		for (int i=0;i<guiConsts.MAX_NUM_COA;i++) {
			if (cbSelectedCogColor[i].isSelected()) {
				coa[i] = calculateCenterOfArea(raster, tfCogColor[i].getBackground());
				coa[i].setColorToDraw(tfCogColor[i].getBackground());
				coa[i].setEnabled(true);
				imageDrawPanel.getCentersOfArea().add(coa[i]);
				tfCogCoords[i].setText("X: "+coa[i].getX()+" Y: "+coa[i].getY());
				tfNumPixels[i].setText(""+coa[i].getArea());
				
				String str = tfWeight[i].getText();
				try {
					dblWeight[i] = Double.valueOf(str);
					coa[i].setWeight(dblWeight[i]);
				}
				catch (NumberFormatException e) {
					JOptionPane.showMessageDialog(this, ""
							+ "The weight"+str+" is not a valid value.", "Number Format Error",
							JOptionPane.ERROR_MESSAGE);
				}
			}
			else {
				coa[i] = new CenterOfArea();
			}
		}
		if (cbSelectedCogColor[guiConsts.MAX_NUM_COA].isSelected()) {
			CenterOfArea coa_total = calculateTotalCenterOfArea(coa);
			coa_total.setTotal(true);
			imageDrawPanel.getCentersOfArea().add(coa_total);
			tfCogCoordTotal.setText("X: "+coa_total.getX()+" Y: "+coa_total.getY());
		}
		else {
			tfCogCoordTotal.setText("");
		}
		imageDrawPanel.repaint();
	}
	
	
	public void setActualCOAColor(Color color) {
		actualCOAColor = color;
	}
		
	public void setImage(BufferedImage im) {
    	image = im;
    	raster = convertTo2D(image);
    }
	
	private CenterOfArea calculateTotalCenterOfArea(CenterOfArea coa[]) {
		CenterOfArea coa_total = new CenterOfArea();
		double maxWeight = coa[0].getWeight();
		double weight;
		double scaledWeight;
		double scaledArea;
		int xm;
		int ym;
		double y;
		double x;
		double area;
		int len = coa.length-1;
		for (int i=0;i<len;i++) {
			weight = coa[i].getWeight();
			if (weight > maxWeight) {
				maxWeight = weight;
			}
		}
		y = 0.0;
		x = 0.0;
		area = 0.0;
		for (int i=0;i<len;i++) {
			weight = coa[i].getWeight();
			scaledWeight = weight / maxWeight;
			scaledArea = coa[i].getArea()*scaledWeight;
			area += scaledArea;
			x+= coa[i].getX() * scaledArea;
			y+= coa[i].getY() * scaledArea;
		}
		if (area > 0.0) {
			xm = (int)Math.round(x / area);
			ym = (int)Math.round(y / area);
		}
		else {
			xm = 0;
			ym = 0;
		}
		coa_total.setX(xm);
		coa_total.setY(ym);
		
		return coa_total;
	}
	
	private CenterOfArea calculateCenterOfArea(Rastered2DImage raster, Color color) {
		
		int xm = 0;
		int ym = 0;
		int count =0;
		
		int rgbValue = color.getRGB();
		
		CenterOfArea  coa = new CenterOfArea ();
		coa.setArea(0);
		coa.setX(0);
		coa.setY(0);
		
		if (raster==null) {
			return coa;
		}
		for (int y=0;y<raster.height;y++) {
			for (int x=0;x<raster.width;x++) {
				if (raster.raster[y][x]==rgbValue) {
					xm += x;
					ym += y;
					count++;
				}
			}	
		}
		if (count > 0) {
			xm = Math.round((float)xm /(float)count);
			ym = Math.round((float)ym /(float)count);
		}
		
		coa.setArea(count);
		coa.setX(xm);
		coa.setY(ym);

		return coa;
	}
	

	private Rastered2DImage convertTo2D(BufferedImage image) {
		Rastered2DImage raster = new Rastered2DImage();
		int width = image.getWidth();
		int height = image.getHeight();
		raster.width = width;
		raster.height = height;
		raster.raster = new int[height][width];
		
		for (int y=0; y<height;y++) {
			for (int x=0; x<width;x++) {
				raster.raster[y][x] = image.getRGB(x, y);
			}
		}
		return raster;
	}
	
	
	private class Rastered2DImage {
		
		public int [][] raster;
		public int width;
		public int height;
		
		public Rastered2DImage() {
			width = 0;
			height = 0;
		}
	}
	


}
