package gui;

import java.awt.Color;
import java.awt.Point;
import java.awt.image.BufferedImage;

import javax.swing.JPanel;
import javax.swing.JTextField;

public class ImageBasePanel extends JPanel{

	private static final long serialVersionUID = 1L;
	private ImageDrawPanel imageDrawPanel;
	private JTextField tfCoords;
	private JTextField lbColor;
	
	private CenterOfAreaPanel centerOfAreaPanel;
	
	public ImageDrawPanel getImageDrawPanel() {
		return imageDrawPanel;
	}
	
	public ImageBasePanel() {
		
		setLayout(null);
		
		imageDrawPanel = new ImageDrawPanel(this);
		
		add(imageDrawPanel);
		
		
		tfCoords = new JTextField();
		tfCoords.setBounds(20,guiConsts.imageDrawPanelHeight+30,80,20);
		add(tfCoords);
		
		
		
		lbColor = new JTextField();
		lbColor.setBounds(110,guiConsts.imageDrawPanelHeight+30,20,20);
		lbColor.setBackground(Color.white);
		add(lbColor);
		
		centerOfAreaPanel = new CenterOfAreaPanel(this);
		centerOfAreaPanel.setLocation(guiConsts.imageDrawPanelWidth+30,20);
		add(centerOfAreaPanel);
		centerOfAreaPanel.setVisible(false);
		
	}
	
	public void showCenterOfAreaPanel() {
		centerOfAreaPanel.setVisible(true);
	}
	
	public BufferedImage captureActualImage() {
		return imageDrawPanel.captureActualImage();
	}
	
	public void setImage(BufferedImage image) {
		imageDrawPanel.setImage(image);
		centerOfAreaPanel.setImage(image);
	}
	
	public void setMouseCoordinates(String coords) {
		tfCoords.setText(coords);
	}
	
	public void setActualPixelColor(Point p, Color color) {
		lbColor.setBackground(color);
		setMouseCoordinates("X:"+p.x+" Y:"+p.y);
		centerOfAreaPanel.setActualCOAColor(color);
		
	}
	
	public void showActualPixelColor(Point p, Color color) {
		lbColor.setBackground(color);
		setMouseCoordinates("X:"+p.x+" Y:"+p.y);
	}
	

	


}
